Whamcloud - gitweb
LU-9219 tests: add missing mgs reformat to conf-sanity/56
[fs/lustre-release.git] / lustre / tests / conf-sanity.sh
old mode 100755 (executable)
new mode 100644 (file)
index 3683fa1..a251e23
@@ -5,7 +5,7 @@ set -e
 ONLY=${ONLY:-"$*"}
 
 # bug number for skipped test:  LU-8972
-ALWAYS_EXCEPT="$CONF_SANITY_EXCEPT"
+ALWAYS_EXCEPT="$CONF_SANITY_EXCEPT 101"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 is_sles11()                                            # LU-2181
@@ -1367,7 +1367,7 @@ test_32newtarball() {
        chown $T32_QID.$T32_QID $tmp/src/t32_qf_old
 
        # format ost with comma-separated NIDs to verify LU-4460
-       local failnid="$(h2$NETTYPE 1.2.3.4),$(h2$NETTYPE 4.3.2.1)"
+       local failnid="$(h2nettype 1.2.3.4),$(h2nettype 4.3.2.1)"
        MGSNID="$MGSNID,$MGSNID" OSTOPT="--failnode=$failnid" formatall
 
        setupall
@@ -1483,7 +1483,8 @@ t32_check() {
 
        local IMGTYPE=$(facet_fstype $SINGLEMDS)
 
-       tarballs=$($r find $RLUSTRE/tests -maxdepth 1 -name \'disk*-$IMGTYPE.tar.bz2\' | grep -v "2_9")
+       tarballs=$($r find $RLUSTRE/tests -maxdepth 1 \
+                  -name \'disk*-$IMGTYPE.tar.bz2\')
 
        if [ -z "$tarballs" ]; then
                skip "No applicable tarballs found"
@@ -2480,9 +2481,9 @@ test_35a() { # bug 12459
        local device=$(do_facet $SINGLEMDS "$LCTL get_param -n devices" |
                awk '($3 ~ "mdt" && $4 ~ "MDT") { print $4 }' | head -1)
        do_facet mgs "$LCTL conf_param \
-                     ${device}.failover.node=$(h2$NETTYPE $FAKENID)" ||
+                     ${device}.failover.node=$(h2nettype $FAKENID)" ||
                error "Setting ${device}.failover.node=\
-                      $(h2$NETTYPE $FAKENID) failed."
+                      $(h2nettype $FAKENID) failed."
 
        log "Wait for RECONNECT_INTERVAL seconds (10s)"
        sleep 10
@@ -2538,9 +2539,9 @@ test_35b() { # bug 18674
        local device=$(do_facet $SINGLEMDS "$LCTL get_param -n devices" |
                awk '($3 ~ "mdt" && $4 ~ "MDT") { print $4 }' | head -1)
        do_facet mgs "$LCTL conf_param \
-                     ${device}.failover.node=$(h2$NETTYPE $FAKENID)" ||
+                     ${device}.failover.node=$(h2nettype $FAKENID)" ||
                error "Set ${device}.failover.node=\
-                      $(h2$NETTYPE $FAKENID) failed"
+                      $(h2nettype $FAKENID) failed"
 
        local at_max_saved=0
        # adaptive timeouts may prevent seeing the issue
@@ -3224,7 +3225,7 @@ test_43b() { # LU-5690
        local client_ip=$(host_nids_address $HOSTNAME $NETTYPE)
        local host=${client_ip//*./}
        local net=${client_ip/%$host/}
-       local nosquash_nids=$(h2$NETTYPE $net[$host,$host,$host])
+       local nosquash_nids=$(h2nettype $net[$host,$host,$host])
 
        add $fs2mgs $(mkfs_opts mgs $fs2mgsdev) --fsname=$fsname \
                --param mdt.root_squash=$RUNAS_ID:$RUNAS_ID \
@@ -3382,8 +3383,9 @@ cleanup_48() {
        reformat_and_config
 }
 
-test_48() { # bug 17636
-       reformat
+test_48() { # bz-17636 LU-7473
+       local count
+
        setup_noconfig
        check_mount || error "check_mount failed"
 
@@ -3394,14 +3396,36 @@ test_48() { # bug 17636
        $GETSTRIPE $MOUNT/widestripe ||
                error "$GETSTRIPE $MOUNT/widestripe failed"
 
-       trap cleanup_48 EXIT ERR
+       # In the future, we may introduce more EAs, such as selinux, enlarged
+       # LOV EA, and so on. These EA will use some EA space that is shared by
+       # ACL entries. So here we only check some reasonable ACL entries count,
+       # instead of the max number that is calculated from the max_ea_size.
+       if [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.8.57) ];
+       then
+               count=28        # hard coded of RPC protocol
+       elif [ $(facet_fstype $SINGLEMDS) != ldiskfs ]; then
+               count=4000      # max_num 4091 max_ea_size = 32768
+       elif ! large_xattr_enabled; then
+               count=450       # max_num 497 max_ea_size = 4012
+       else
+               count=4500      # max_num 8187 max_ea_size = 1048492
+                               # not create too much (>5000) to save test time
+       fi
 
-       # fill acl buffer for avoid expand lsm to them
-       getent passwd | awk -F : '{ print "u:"$1":rwx" }' |  while read acl; do
-           setfacl -m $acl $MOUNT/widestripe
+       echo "It is expected to hold at least $count ACL entries"
+       trap cleanup_48 EXIT ERR
+       for ((i = 0; i < $count; i++)) do
+               setfacl -m u:$((i + 100)):rw $MOUNT/widestripe ||
+                       error "Fail to setfacl for $MOUNT/widestripe at $i"
        done
 
+       cancel_lru_locks mdc
        stat $MOUNT/widestripe || error "stat $MOUNT/widestripe failed"
+       local r_count=$(getfacl $MOUNT/widestripe | grep "user:" | wc -l)
+       count=$((count + 1)) # for the entry "user::rw-"
+
+       [ $count -eq $r_count ] ||
+               error "Expected ACL entries $count, but got $r_count"
 
        cleanup_48
 }
@@ -4145,9 +4169,7 @@ test_56a() {
 
        MDSJOURNALSIZE=16
 
-       for num in $(seq 1 $MDSCOUNT); do
-               format_mdt $num
-       done
+       formatall
        add ost1 $(mkfs_opts ost1 $(ostdevname 1)) --index=10000 --reformat \
                $(ostdevname 1) $(ostvdevname 1)
        add ost2 $(mkfs_opts ost2 $(ostdevname 2)) --index=1000 --reformat \
@@ -5342,6 +5364,34 @@ test_76c() {
 }
 run_test 76c "verify changelog_mask is applied with set_param -P"
 
+test_76d() { #LU-9399
+       setupall
+
+       local xattr_cache="llite.*.xattr_cache"
+       local cmd="$LCTL get_param -n $xattr_cache | head -1"
+       local new=$((($(eval $cmd) + 1) % 2))
+
+       echo "lctl set_param -P llite.*.xattr_cache=$new"
+       do_facet mgs $LCTL set_param -P $xattr_cache=$new ||
+               error "Can't change xattr_cache"
+       wait_update $HOSTNAME "$cmd" "$new"
+
+       echo "Check $xattr_cache on client $MOUNT"
+       umount_client $MOUNT || error "umount $MOUNT failed"
+       mount_client $MOUNT || error "mount $MOUNT failed"
+       [ $(eval $cmd) -eq $new ] ||
+               error "$xattr_cache != $new on client $MOUNT"
+
+       echo "Check $xattr_cache on the new client $MOUNT2"
+       mount_client $MOUNT2 || error "mount $MOUNT2 failed"
+       [ $(eval $cmd) -eq $new ] ||
+               error "$xattr_cache != $new on client $MOUNT2"
+       umount_client $MOUNT2 || error "umount $MOUNT2 failed"
+
+       stopall
+}
+run_test 76d "verify llite.*.xattr_cache can be set by 'set_param -P' correctly"
+
 test_77() { # LU-3445
        local server_version=$(lustre_version_code $SINGLEMDS)
        [[ $server_version -ge $(version_code 2.8.55) ]] ||
@@ -5358,7 +5408,9 @@ test_77() { # LU-3445
        local fs2ostvdev=$(ostvdevname 1_2)
        local fsname=test1234
        local mgsnid
-       local failnid="$(h2$NETTYPE 1.2.3.4),$(h2$NETTYPE 4.3.2.1)"
+       local failnid="$(h2nettype 1.2.3.4),$(h2nettype 4.3.2.1)"
+
+       combined_mgs_mds || stop_mgs || error "stopping MGS service failed"
 
        add fs2mds $(mkfs_opts mds1 $fs2mdsdev) --mgs --fsname=$fsname \
                --reformat $fs2mdsdev $fs2mdsvdev || error "add fs2mds failed"
@@ -5366,9 +5418,9 @@ test_77() { # LU-3445
                error "start fs2mds failed"
 
        mgsnid=$(do_facet fs2mds $LCTL list_nids | xargs | tr ' ' ,)
-       mgsnid="$mgsnid,$mgsnid:$mgsnid"
+       mgsnid="0.0.0.0@tcp,$mgsnid,$mgsnid:$mgsnid"
 
-       add fs2ost $(mkfs_opts ost1 $fs2ostdev) --mgsnode=$mgsnid \
+       add fs2ost --mgsnode=$mgsnid $(mkfs_opts ost1 $fs2ostdev) \
                --failnode=$failnid --fsname=$fsname \
                --reformat $fs2ostdev $fs2ostvdev ||
                        error "add fs2ost failed"
@@ -5903,8 +5955,8 @@ run_test 82b "specify OSTs for file with --pool and --ost-list options"
 test_83() {
        [[ $(lustre_version_code ost1) -ge $(version_code 2.6.91) ]] ||
                { skip "Need OST version at least 2.6.91" && return 0; }
-       if [ $(facet_fstype $SINGLEMDS) != ldiskfs ]; then
-               skip "Only applicable to ldiskfs-based MDTs"
+       if [ $(facet_fstype ost1) != ldiskfs ]; then
+               skip "Only applicable to ldiskfs-based OSTs"
                return
        fi
 
@@ -5920,7 +5972,7 @@ test_83() {
        # Mount the OST as an ldiskfs filesystem.
        log "mount the OST $dev as a $fstype filesystem"
        add ost1 $(mkfs_opts ost1 $dev) $FSTYPE_OPT \
-               --reformat $dev $dev > /dev/null ||
+               --reformat $dev > /dev/null ||
                error "format ost1 error"
 
        if ! test -b $dev; then
@@ -6133,7 +6185,8 @@ test_87() { #LU-6544
        #set xattr
        $SETSTRIPE -E 1M -c 1 -E 64M -c 1 -E -1 -c -1 $file ||
                error "Create file with 3 components failed"
-       i=$($GETSTRIPE -I 3 -c $file)
+       $TRUNCATE $file $((1024*1024*64+1)) || error "truncate file failed"
+       i=$($GETSTRIPE -I3 -c $file) || error "get 3rd stripe count failed"
        if [ $i -ne $OSTCOUNT ]; then
                left_size=$(expr $left_size + $(expr $OSTCOUNT - $i) \* 24)
                echo -n "Since only $i out $OSTCOUNT OSTs are used, "
@@ -7310,6 +7363,115 @@ test_103() {
 }
 run_test 103 "rename filesystem name"
 
+test_104() { # LU-6952
+       local mds_mountopts=$MDS_MOUNT_OPTS
+       local ost_mountopts=$OST_MOUNT_OPTS
+       local mds_mountfsopts=$MDS_MOUNT_FS_OPTS
+       local lctl_ver=$(do_facet $SINGLEMDS $LCTL --version |
+                       awk '{ print $2 }')
+
+       [[ $(version_code $lctl_ver) -lt $(version_code 2.9.55) ]] &&
+               { skip "this test needs utils above 2.9.55" && return 0; }
+
+       # specify "acl" in mount options used by mkfs.lustre
+       if [ -z "$MDS_MOUNT_FS_OPTS" ]; then
+               MDS_MOUNT_FS_OPTS="acl,user_xattr"
+       else
+
+               MDS_MOUNT_FS_OPTS="${MDS_MOUNT_FS_OPTS},acl,user_xattr"
+       fi
+
+       echo "mountfsopt: $MDS_MOUNT_FS_OPTS"
+
+       #reformat/remount the MDT to apply the MDT_MOUNT_FS_OPT options
+       formatall
+       if [ -z "$MDS_MOUNT_OPTS" ]; then
+               MDS_MOUNT_OPTS="-o noacl"
+       else
+               MDS_MOUNT_OPTS="${MDS_MOUNT_OPTS},noacl"
+       fi
+
+       for num in $(seq $MDSCOUNT); do
+               start mds$num $(mdsdevname $num) $MDS_MOUNT_OPTS ||
+                       error "Failed to start MDS"
+       done
+
+       for num in $(seq $OSTCOUNT); do
+               start ost$num $(ostdevname $num) $OST_MOUNT_OPTS ||
+                       error "Failed to start OST"
+       done
+
+       mount_client $MOUNT
+       setfacl -m "d:$RUNAS_ID:rwx" $MOUNT &&
+               error "ACL is applied when FS is mounted with noacl."
+
+       MDS_MOUNT_OPTS=$mds_mountopts
+       OST_MOUNT_OPTS=$ost_mountopts
+       MDS_MOUNT_FS_OPTS=$mds_mountfsopts
+
+       formatall
+       setupall
+}
+run_test 104 "Make sure user defined options are reflected in mount"
+
+error_and_umount() {
+       umount $TMP/$tdir
+       rmdir $TMP/$tdir
+       error $*
+}
+
+test_105() {
+       cleanup
+       reformat
+       setup
+       mkdir -p $TMP/$tdir
+       mount --bind $DIR $TMP/$tdir || error "mount bind mnt pt failed"
+       rm -f $TMP/$tdir/$tfile
+       rm -f $TMP/$tdir/${tfile}1
+
+       # Files should not be created in ro bind mount point
+       # remounting from rw to ro
+       mount -o remount,ro $TMP/$tdir ||
+               error_and_umount "readonly remount of bind mnt pt failed"
+       touch $TMP/$tdir/$tfile &&
+               error_and_umount "touch succeeds on ro bind mnt pt"
+       [ -e $TMP/$tdir/$tfile ] &&
+               error_and_umount "file created on ro bind mnt pt"
+
+       # Files should be created in rw bind mount point
+       # remounting from ro to rw
+       mount -o remount,rw $TMP/$tdir ||
+               error_and_umount "read-write remount of bind mnt pt failed"
+       touch $TMP/$tdir/${tfile}1 ||
+               error_and_umount "touch fails on rw bind mnt pt"
+       [ -e $TMP/$tdir/${tfile}1 ] ||
+               error_and_umount "file not created on rw bind mnt pt"
+       umount $TMP/$tdir || error "umount of bind mnt pt failed"
+       rmdir $TMP/$tdir
+       cleanup || error "cleanup failed with $?"
+}
+run_test 105 "check file creation for ro and rw bind mnt pt"
+
+test_107() {
+       [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.10.50) ]] ||
+               { skip "Need MDS version > 2.10.50"; return; }
+
+       start_mgsmds || error "start_mgsmds failed"
+       start_ost || error "unable to start OST"
+
+       # add unknown configuration parameter.
+       local PARAM="$FSNAME-OST0000.ost.unknown_param=50"
+       do_facet mgs "$LCTL conf_param $PARAM"
+       cleanup_nocli || error "cleanup_nocli failed with $?"
+       load_modules
+
+       # unknown param should be ignored while mounting.
+       start_ost || error "unable to start OST after unknown param set"
+
+       cleanup || error "cleanup failed with $?"
+}
+run_test 107 "Unknown config param should not fail target mounting"
+
 if ! combined_mgs_mds ; then
        stop mgs
 fi